
public class Stack<S> {
	
	private Node<S> start;		//initialisiert den Start der Liste bzw des ersten knoten	
	
	private int size;			//initialisiert die größe der Liste bzw die variable dafür
	
	public Stack() {				//Konstrukter der die Startwertde der liste angibt
		this.start = null;		//Startwert für "start" ist "null"
		this.size = 0;			//Startwert für die größe alos "size" ist 0
	}
	
	
	public boolean isEmpty() {	//Methode für den test ob die liste leer ist
		if(size == 0) {	//solange die größe noch 0 ist
			return true;		//positiver ergebnis, dass die Liste leer ist
		} else {		//ansonsten
			return false;	 //negative ergebnis, ass die liste Werte enthält
		}
	}
	
	public void push(S wert) {
		size++;
		
		Node<S> Neu = new Node<S>(wert);	//neuer knoten der den eingegebenen wert als "wert" erhält um den dann an der richtigen stelle einzuschieben
		Neu.next = start;	//der neue Knoten wird zum start Knoten
		start = Neu;	//der "Neu.next" wird mit der Zeile drüber zu "Neu"
		
	}
	
	public S pop() {					//entfernt das oberste Element der stacks und gibt den darauf gespeicherten wert aus oder "null"
		Node<S> current = this.start;	//initialisiert den Knoten current
		if(isEmpty() == true) {			//wenn das Ergebnis aus isEmpty() true ist...
			return null;																//...stoppt er
		} else { 						//ansonsten
			S I = current.wert;			//speiichert den wert in I
			this.start = current.next;	//start wird zum nächsten wert vom aktuellen Knoten aus
			return I;					//gibt den wert zurück
		}
	}
	
	public S top() {	//gibt den obersten wert des stacks aus  oder "null"
		Node<S> current = this.start;	//initialisiert den Knoten current
		if(isEmpty() == true) {	//wenn das Ergebnis aus isEmpty() true ist...
			return null;														//...stoppt er
		} else {
			S I = current.wert;	//speichert den wert in I
			return I;		//gibt den wert aus
		}
	}
	
	
	public Node<S> getStart() { //erstellt start zum getten
		return this.start;		//gibt start zurück
	}
	
	public int size() {	//erstellt size zum getten
		return this.size;	//gibt size zurück
	}
	public void Ausgabe() {
		Node<S> current = this.start;	//initialisiert die liste
				
			while(current != null) {	//solange current also der aktuelle Wert ungleich "null" ist
				System.out.print(current.wert + " ");	//gibt den aktuellen Wert aus
				current = current.next;	//geht zum nächsten Wert
			}
	}
	
}
